
!IndexedCollection methodsFor: 'vector extensions'!
   
with: array1 with: array2 with: array3 with: array4 with: array5 set: aBlock
	"See with:set:"
	1 to: self size do: [:index |
		self
			at: index
			put: (aBlock evaluateWithArguments: ((Array new: 5)
				at: 1 put: (array1 at: index);
				at: 2 put: (array2 at: index);
				at: 3 put: (array3 at: index);
				at: 4 put: (array4 at: index);
				at: 5 put: (array5 at: index);
				yourself))]
!

assign: array
	"Equivalent to 'self with: array1 set: [:item | item]'."
	1 to: self size do: [:index |
		self at: index put: (array at: index)]
!
   
with: array1 with: array2 with: array3 set: aBlock
	"See with:set:"
	1 to: self size do: [:index |
		self
			at: index
			put: (aBlock
				value: (array1 at: index)
				value: (array2 at: index)
				value: (array3 at: index))]
!
   
with: array1 with: array2 with: array3 with: array4 set: aBlock
	"See with:set:"
	1 to: self size do: [:index |
		self
			at: index
			put: (aBlock
				value: (array1 at: index)
				value: (array2 at: index)
				value: (array3 at: index)
				value: (array4 at: index))]
!
   
with: array1 set: aBlock
	"Instead of writing
		For each i,     test1 at: i put: (test2 at: i) computeValue.
	User writes
		test1 with: test2 set: [:value2 | value2 computeValue]
	Method takes care of iterating, indexing, and storing the value in test1.

	Multiple with:'s provide corresponding multiple values to work from."

	1 to: self size do: [:index |
		self
			at: index
			put: (aBlock
				value: (array1 at: index))]
!
   
set: aBlock
	"anArray set: [20]"
	1 to: self size do: [:index |
		self at: index put: (aBlock value)]
!
 
with: array1 with: array2 set: aBlock
	"See with:set:"
	1 to: self size do: [:index |
		self
			at: index
			put: (aBlock
				value: (array1 at: index)
				value: (array2 at: index))]
! !
